/*
 *    main.cpp
 *
 *    Kambariu nuoma
 *
 */
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;
//------------------------------------------------------------
struct Room
{
    int      space;
    int      number;
    string   clas;  // "Single", "Double", "Family"
    double   dayPrice;
    int      rentedByCustomer;  // numeruosime nuo 1
    double   moneyEarned;
    int      timesRented;
    int      mostRented;
    
};
typedef vector<Room> Rooms;
//------------------------------------------------------------
struct Customer
{
    string   name;
    string   surname;
    string   personalCode;
    double   moneyEarned;
};
typedef vector<Customer> Customers;
//------------------------------------------------------------
void printRooms     (const Rooms&     rooms);
void printCustomers (const Customers&  customers);
void addRoom        (      Rooms&     rooms);
void addCustomer    (      Customers&  customers);
void rentRoom       (      Rooms&     rooms, Customers& customers);
void printFreeRooms (const Rooms&     rooms);
void mostPopular    (      Rooms& rooms);
void mostEarned     (      Rooms& rooms);

//--------------------------------
void printMenu ()
{
    cout << endl
         << "Kambariu nuoma:" << endl
         << "  1 - Spausdinti kambarius"     << endl
         << "  1a - Spausdinti pelningiausia kambari"     << endl
         << "  1b - Spausdinti dazniausiai nuomota kambari"     << endl
         << "  2 - Prideti nauja kambari"   << endl
         << "  3 - Isnuomuoti klientui"   << endl
         << "  4 - Laisvi kambariai"      << endl
	 <<endl
         << "  5 - Spausdinti klientus"   << endl
         << "  6 - Prideti nauja klienta" << endl
         << endl
         << "  0 - Baigti darba"   << endl;
}
//------------------------------------------------------------
int main ()
{
    Rooms     rooms;
    Customers  customers;
    
    for (;;)
    {
        cout << "\n----------------------------------------\n";
        cout << "(m - rodyti meniu) > ";
        string key;
        cin >> key;
             if (key == "0") return 0;
        else if (key == "m") printMenu      ();
        else if (key == "1") printRooms     (rooms);
             else if (key == "1a") mostEarned     (rooms);
             else if (key == "1b") mostPopular      (rooms);
        else if (key == "2") addRoom        (rooms);
        else if (key == "3") rentRoom       (rooms, customers);
        else if (key == "4") printFreeRooms (rooms);
        else if (key == "5") printCustomers (customers);
        else if (key == "6") addCustomer    (customers);
        else cout << endl << "Neteisinga komanda..." << endl;   
    }
    
}
//------------------------------------------------------------
void printRooms    (const Rooms& rooms)
{
    cout << "Kambariu kiekis: " << rooms.size() << endl;
    for (int i = 0;  i < rooms.size();  i++)
    {
        cout << (i+1) 
             << ". "  << rooms[i].rentedByCustomer
             << "\t"  << rooms[i].clas
             << " "   << rooms[i].dayPrice << "Lt"
             << "\t(" << rooms[i].moneyEarned << "Lt)"
             << "\t"  << rooms[i].number
             << "\t"  << rooms[i].space
             << "\t"  << rooms[i].timesRented
             << "\t"  << rooms[i].mostRented
             << endl;
    }                 
}
//------------------------------------------------------------
void mostEarned ( Rooms& rooms)
{
     int money = 0;
     double mostEarned = 0;
     for (int i=0; i < rooms.size(); i++)
         if (rooms[i].moneyEarned > mostEarned)
     {
         mostEarned = rooms[i].moneyEarned;
         money = i;
     }
     cout << "Pelningiausias kambarys: " << endl
          << (money + 1)
          <<". " << rooms[money].number
          <<"\t" << rooms[money].space
          <<"\t" << rooms[money].clas
          <<"\t" "Uzdirbo: " << rooms[money].moneyEarned << "Lt"
          << endl;
}
//-------------------
void mostPopular ( Rooms& rooms)
{         
     int times = 0;
     int mostRented = 0;
     for (int i = 0; i < rooms.size(); i++)
          if (rooms[i].timesRented > mostRented)
          {
              mostRented = rooms[i].timesRented;
              times = i;
          }
     cout << "Populiariausias kambarys: " << endl
          << (times + 1)
          << ". " << rooms[times].number
          << "\t" << rooms[times].space
          << "\t" << rooms[times].clas
          << "\t" "Isnuomotas: " << rooms[times].timesRented << " kartu "
          <<endl;
}
//--------------------------------------------------------------
void printCustomers (const Customers& customers)
{
    cout << "Klietu kiekis: " << customers.size() << endl;
    for (int i = 0;  i < customers.size();  i++)
    {
        cout << (i+1) 
             << ". (" << customers[i].moneyEarned << "Lt)"
             << "\t"  << customers[i].name
             << " ("  << customers[i].surname << ")"
             << " ("  << customers[i].personalCode << ")"  
             << endl;
    }
}
//------------------------------------------------------------
void addRoom (Rooms& rooms)
{
    cin.ignore(INT_MAX, '\n'); // ignoruojam uzsilikusi klaviaturos ENTER
    Room room;
    cout << "Iveskite nauja kambari:" << endl;
    cout << "    numeris       : ";  cin >> room.number;
    cout << "    vietu kiekis  : ";  cin >> room.space;
    cout << "    Single/Double/Family   : ";  cin >> room.clas;
    cout << "    kaina dienai(Lt) : ";  cin >> room.dayPrice;
    room.rentedByCustomer =  0;
    room.moneyEarned      =  0;
    room.timesRented      =  0;
    room.mostRented       =  0;
    rooms.push_back(room);   
}
//------------------------------------------------------------
void addCustomer (Customers& customers)
{
    cin.ignore(INT_MAX, '\n'); // ignoruojam uzsilikusi klaviaturos ENTER
    Customer customer;
    cout << "Iveskite nauja klienta:" << endl;
    cout << "    vardas : ";  getline(cin, customer.name);
    cout << "    pavarde: ";  getline(cin, customer.surname);
    cout << "    asmens kodas: ";  getline(cin, customer.personalCode);
    customer.moneyEarned = 0;
    customers.push_back(customer);   
}
//------------------------------------------------------------
void rentRoom (Rooms& rooms, Customers& customers)
{
     int roomNo = 0;
     printRooms (rooms);
     cout << "Iveskit kambario eiles numeri: ";
     cin  >> roomNo;
     if (roomNo <= 0  ||  roomNo > rooms.size())
     {
         cout << "KLAIDA: nera kambario su ivestu eiles numeriu.";
         return;
     }
     if (rooms[roomNo-1].rentedByCustomer != 0)
     {
         cout << "KLAIDA: kambarys jau yra isnuomotas.";
         return;
     }
     
     int customerNo = 0;
     printCustomers (customers);
     cout << "Pasirinkite kliento eiles numeri: ";
     cin  >> customerNo;
     if (customerNo <= 0  ||  customerNo > customers.size())
     {
         cout << "KLAIDA: nera kliento su ivestu eiles numeriu.";
         return;
     }
     
     int dayCount;
     cout << "Keliom dienom nuomuosime        : ";
     cin  >> dayCount;     
     rooms[roomNo-1].rentedByCustomer   = customerNo;
     rooms[roomNo-1].moneyEarned       += dayCount * rooms[roomNo-1].dayPrice;
     customers[customerNo-1].moneyEarned += dayCount * rooms[roomNo-1].dayPrice;
     rooms[roomNo-1].mostRented         ++;
     rooms[roomNo].timesRented++; 
}
//------------------------------------------------------------
void printFreeRooms    (const Rooms&     rooms)
{

     Rooms freeRooms;
     
     for (int i = 0;  i < rooms.size();  i++)
     {
         if(rooms[i].rentedByCustomer==0)
         {
            cout << (i+1)
                 << "Kambrio numeris:    " << rooms[i].number              <<endl
                 << "Kambario vietu sk.: " << rooms[i].space               <<endl
                 << "Kambario klase:     " << rooms[i].clas                <<endl
                 <<endl;
         }
                 
     }
}
//============================================================

